"""
Jeu de dames
Version 3 -> Mise en place des déplacements
=> (ok) affichage du texte sur la fenêtre graphique
=> (ok) sauter en arrière
=> (ok) pion devient dame
"""
from jeu_dame_V3 import *

# ================================================================ clic_plateau
def clic_plateau ( screen:object, case:tuple, pions:list ):
    pion_actif = False
    case_vide = True
    for pion in pions : # passer tous les pions en revue
        if pion.position == case :
            pion_sur_case = pion # il y a un pion sur la case
            case_vide = False
        if pion.actif :
            pion_move = pion # il existe un pion actif
            pion_actif = True
    if not pion_actif and not case_vide : # s'il n'y avait pas de pion actif
        pion_sur_case.activer(screen, pions) # activer le pion
    elif pion_actif and case_vide :
        deplacer_pion_plateau ( screen, case, pion_move, pions )
    elif pion_actif :
        pion_move.desactiver(screen) # désactiver le pion

# ================================================================ deplacer_pion_plateau
def deplacer_pion_plateau ( screen:object, case:tuple, pion:object, pions:list ) :
    # Le pion ne peut que avancer en diagonal ou sauter un autre pion
    # si pion rouge -> avancer # si pion bleu reculer
    # (rouge) Si case est ligne+1 et col-1 ou col+1 -> move OK
    # sinon, si case est ligne+2 et col-2 ou col+2 et case vide
        # si pion autre couleur sur case ligne+1 et col-1 ou col+1 -> prendre pion, move OK
    # Si move OK et dernière ligne -> "dame"
    pion_lgn, pion_col = pion.position
    case_lgn, case_col = case
    sens = 1 if 'R' in pion.couleur else -1 # pion rouge -> avancer, bleu reculer
    # ========== déplacer un pion d'une seule case ==========
    if case_lgn == pion_lgn+sens and not pion.dame: 
        if case_col == pion_col+1 or case_col == pion_col-1 : # move OK
            pion.deplacer(screen, case)
    # ========== un pion saute un autre pion ==========
    elif not pion.dame : # c'est un pion -> déplacement simple        
        if case_lgn == pion_lgn+2 or case_lgn == pion_lgn-2 : # sauter par dessus un pion ?
            if case_col == pion_col+2 or case_col == pion_col-2 :
                col = pion_col+(case_col - pion_col)//2 # colonne au milieu du saut
                for p in pions : # existe-il un pion entre position et destination ?
                    p_lgn, p_col = p.position
                    if p_lgn == pion_lgn+sens or p_lgn == pion_lgn-sens:
                        if p_col == col : # le pion sauté est au lieu
                            supprimer = False
                            if 'R' in p.couleur and 'B' in pion.couleur : 
                                    supprimer = True # pion adverse -> sauter
                            if 'B' in p.couleur and 'R' in pion.couleur : 
                                    supprimer = True # pion adverse -> sauter
                            if supprimer :    
                                pion.sauter(screen, p, case, pions)
                            else:
                                pion.desactiver(screen)
    # ========== une dame saute un pion ==========
    elif pion.dame : 
        # vérifier que c'est bien un déplacement en diagonal
        nb_lgn = case_lgn - pion_lgn if case_lgn > pion_lgn else pion_lgn - case_lgn
        nb_col = case_col - pion_col if case_col > pion_col else pion_col - case_col
        droite = 1 if pion_col > case_col else -1 # gauche ou droite ?
        bas = 1 if pion_lgn > case_lgn else -1 # bas ou haut ?
        if nb_lgn == nb_col : # Ok en diagonal
            # existe-il UN SEUL pion entre position et destination ?
            pion_present = False
            for i in range(1,nb_lgn) : # pour chaque case, y a-t-il un pion ? 
                for p in pions : 
                    p_lgn, p_col = p.position
                    if p_lgn == pion_lgn - bas*i and p_col == pion_col - droite*i :
                        if not pion_present : # premier pion trouvé
                            pion_present = True
                            p_trouve = p
                        else :
                            pion.desactiver(screen) # plusieurs pions !!
                            return
            if pion_present : # un seul piont trouvé entre position et destination
                supprimer = False
                if pion.couleur=='RD' and 'B' in p_trouve.couleur:
                    supprimer = True
                if pion.couleur=='BD' and 'R' in p_trouve.couleur:
                    supprimer = True
                if supprimer :
                    pion.sauter(screen, p_trouve, case, pions)
                else :
                    pion.desactiver(screen) # pion même couleur
                    return
            else :
                pion.deplacer(screen, case)

# =======================================================================
# =============================================================== main
debut_jeu( screen )

dessiner_plateau ( screen ) # création du plateau de jeu 8 par 8

for col in range(1,9) : # créer les pions et les placer
    lgn = 2 if col%2 else 1 
    pions.append( pion ( c_rouge, (lgn, col), screen) )
    pions.append( pion ( c_bleu, (lgn+6, col), screen) )

clock = pygame.time.Clock()
fin = False    
while not fin :
    for event in pygame.event.get() :
        if event.type == pygame.QUIT:
            fin = True
        if event.type == pygame.MOUSEBUTTONDOWN:
            pos = pygame.mouse.get_pos()
            lgn = pos[1]//50+1 # case où se situe le clic
            col = pos[0]//50+1
            clic_plateau ( screen, (lgn, col), pions)
            fin = tester_fin_jeu ( screen, pions )
            
    clock.tick(60) # attendre
    pygame.display.flip() # mettre à jour

pygame.quit()
 
    
    